
Infrastructure - Task #719

Story # 957 (Closed): CN Service layer should be refactored for 0.6 release

Add Better DataONE exceptions into Cn Rest Service Proxy

2010-07-22 15:16 - Dave Vieglais

Status: Closed Start date:  

Priority: High Due date:  

Assignee: Robert Waltz % Done: 100%

Category: d1_cn_service Estimated time: 0.00 hour

Target version: Sprint-2011.12-Block.2   

Milestone: CCI-0.5 Story Points:  

Product Version: *   

Description

Expecting http://cn-dev.dataone.org/cn/object/ to return an object or an appropriate exception if not found.

e.g.: http://cn-dev.dataone.org/cn/object/knb:testid:201020017138261

Instead the generic 404 is returned.

Similarly with /cn/object, /cn/meta/

Incorrect URL paths or REST services not functional?

Service endpoints that do not exhibit any defined action should provide the caller with hints about the service URLs that are available

on the node.  This applies for both CNs and MNs and is useful for guiding outside users towards appropriate use of the system.  The

response should be an exception of type InvalidRequest.  The description of the error message should include references to

supported collectiosn on the system (even if authentication is required to access those collections).  For example, the description in

the error response of GET /cn could be:

No action is available for the specified URL.  Available actions include:

objectList objects available on this node

object/IDRetrieve the specified object

meta/IDRetrieve system metadata for the specified object

checksum/IDRetrieve the checksum for the specified object

logAccess the use logs

resolve/IDReturn a list of locations from which the specified object can be retieved

 

History

#1 - 2010-10-07 00:36 - Robert Waltz

- Parent task set to #957

- Milestone set to CCI-0.6

#2 - 2010-10-07 21:46 - Robert Waltz

- Milestone changed from CCI-0.6 to CCI-0.5

#3 - 2011-03-28 16:29 - Robert Waltz

- Status changed from New to Closed
